DependenciesConfiguration (Grails 2.4.4)
Date: 2014-10-28

Package: org.codehaus.groovy.grails.resolve.maven.aether.config

## [Groovy] Class DependenciesConfiguration

- org.codehaus.groovy.grails.resolve.maven.aether.config.DependenciesConfiguration

- Authors:
    Graeme Rocher
  Since:
    2.3

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static java.util.List` | `ALL_SCOPES` |
    `static java.lang.String` | `SCOPE_BUILD` |
    `static java.lang.String` | `SCOPE_COMPILE` |
    `static java.lang.String` | `SCOPE_OPTIONAL` |
    `static java.lang.String` | `SCOPE_PROVIDED` |
    `static java.lang.String` | `SCOPE_RUNTIME` |
    `static java.lang.String` | `SCOPE_TEST` |

  - ### Properties Summary

    Properties
    Type | Name and description
    --- | ---
    `static java.util.regex.Pattern` | `DEPENDENCY_PATTERN`
    `AetherDependencyManager` | `dependencyManager`
    `org.eclipse.aether.util.graph.selector.ExclusionDependencySelector` | `exclusionDependencySelector`

  - ### Constructor Summary

    Constructors
    Constructor and description
    `DependenciesConfiguration (AetherDependencyManager dependencyManager)`

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `void` | `addBuildDependency(org.eclipse.aether.graph.Dependency dependency, groovy.lang.Closure customizer = null)`
    `protected void` | `addBuildDependency(java.util.Map<java.lang.String, java.lang.String> properties, java.lang.String scope, groovy.lang.Closure customizer = null)`
    `void` | `addBuildDependency(Dependency dependency)`
    `protected java.lang.Object` | `addBuildDependencyToManager(DependencyConfiguration dependencyConfig)`
    `void` | `addDependency(org.eclipse.aether.graph.Dependency dependency, groovy.lang.Closure customizer = null)`
    `protected void` | `addDependency(java.util.Map<java.lang.String, java.lang.String> properties, java.lang.String scope, groovy.lang.Closure customizer = null)`
    `void` | `addDependency(Dependency dependency, java.lang.String scope)`
    `protected java.lang.Object` | `addDependencyToManager(DependencyConfiguration dependencyConfig)`
    `void` | `agent(java.lang.String pattern)` Configure the JAR to use for the reloading agent
    `void` | `build(java.lang.String pattern, groovy.lang.Closure customizer = null)`
    `void` | `build(java.util.Map<java.lang.String, java.lang.String> properties, groovy.lang.Closure customizer = null)`
    `void` | `compile(java.lang.String pattern, groovy.lang.Closure customizer = null)`
    `void` | `compile(java.util.Map<java.lang.String, java.lang.String> properties, groovy.lang.Closure customizer = null)`
    `org.eclipse.aether.graph.Dependency` | `createDependencyForProperties(java.util.Map<java.lang.String, java.lang.String> properties, java.lang.String scope)`
    `protected DependencyConfiguration` | `customizeDependency(groovy.lang.Closure customizer, org.eclipse.aether.graph.Dependency dependency)`
    `java.lang.Object` | `environments(groovy.lang.Closure callable)` Environment support
    `protected java.util.Map` | `extractDependencyProperties(java.lang.String pattern)`
    `protected java.lang.String` | `getDefaultExtension()`
    `protected java.lang.String` | `getDefaultGroup()`
    `void` | `invokeForString(java.lang.String scope, java.util.List<java.lang.Object> objects, groovy.lang.Closure configurer = null)`
    `java.lang.Object` | `methodMissing(java.lang.String name, java.lang.Object args)`
    `void` | `optional(java.lang.String pattern, groovy.lang.Closure customizer = null)`
    `void` | `optional(java.util.Map<java.lang.String, java.lang.String> properties, groovy.lang.Closure customizer = null)`
    `void` | `provided(java.lang.String pattern, groovy.lang.Closure customizer = null)`
    `void` | `provided(java.util.Map<java.lang.String, java.lang.String> properties, groovy.lang.Closure customizer = null)`
    `void` | `runtime(java.lang.String pattern, groovy.lang.Closure customizer = null)`
    `void` | `runtime(java.util.Map<java.lang.String, java.lang.String> properties, groovy.lang.Closure customizer = null)`
    `void` | `test(java.lang.String pattern, groovy.lang.Closure customizer = null)`
    `void` | `test(java.util.Map<java.lang.String, java.lang.String> properties, groovy.lang.Closure customizer = null)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Field Detail

    - #### public static final java.util.List ALL_SCOPES

    - #### public static final java.lang.String SCOPE_BUILD

    - #### public static final java.lang.String SCOPE_COMPILE

    - #### public static final java.lang.String SCOPE_OPTIONAL

    - #### public static final java.lang.String SCOPE_PROVIDED

    - #### public static final java.lang.String SCOPE_RUNTIME

    - #### public static final java.lang.String SCOPE_TEST

  - ### Property Detail

    - #### static final java.util.regex.Pattern DEPENDENCY_PATTERN

    - #### AetherDependencyManager dependencyManager

    - #### org.eclipse.aether.util.graph.selector.ExclusionDependencySelector exclusionDependencySelector

  - ### Constructor Detail

    - #### DependenciesConfiguration(AetherDependencyManager dependencyManager)

  - ### Method Detail

    - #### void addBuildDependency(org.eclipse.aether.graph.Dependency dependency, @groovy.lang.DelegatesTo(DependencyConfiguration) groovy.lang.Closure customizer = null)

    - #### protected void addBuildDependency(java.util.Map<java.lang.String, java.lang.String> properties, java.lang.String scope, groovy.lang.Closure customizer = null)

    - #### void addBuildDependency(Dependency dependency)

    - #### protected java.lang.Object addBuildDependencyToManager(DependencyConfiguration dependencyConfig)

    - #### void addDependency(org.eclipse.aether.graph.Dependency dependency, @groovy.lang.DelegatesTo(DependencyConfiguration) groovy.lang.Closure customizer = null)

    - #### protected void addDependency(java.util.Map<java.lang.String, java.lang.String> properties, java.lang.String scope, groovy.lang.Closure customizer = null)

    - #### void addDependency(Dependency dependency, java.lang.String scope)

    - #### protected java.lang.Object addDependencyToManager(DependencyConfiguration dependencyConfig)

    - #### void agent(java.lang.String pattern)

      Configure the JAR to use for the reloading agent

      Parameters:
        `pattern` - The version pattern

    - #### void build(java.lang.String pattern, @groovy.lang.DelegatesTo(DependencyConfiguration) groovy.lang.Closure customizer = null)

    - #### void build(java.util.Map<java.lang.String, java.lang.String> properties, @groovy.lang.DelegatesTo(DependencyConfiguration) groovy.lang.Closure customizer = null)

    - #### void compile(java.lang.String pattern, @groovy.lang.DelegatesTo(DependencyConfiguration) groovy.lang.Closure customizer = null)

    - #### void compile(java.util.Map<java.lang.String, java.lang.String> properties, @groovy.lang.DelegatesTo(DependencyConfiguration) groovy.lang.Closure customizer = null)

    - #### org.eclipse.aether.graph.Dependency createDependencyForProperties(java.util.Map<java.lang.String, java.lang.String> properties, java.lang.String scope)

    - #### protected DependencyConfiguration customizeDependency(groovy.lang.Closure customizer, org.eclipse.aether.graph.Dependency dependency)

    - #### java.lang.Object environments(groovy.lang.Closure callable)

      Environment support

      Parameters:
        `callable` - The callable
      Returns:
        The result of the environments block

    - #### protected java.util.Map extractDependencyProperties(java.lang.String pattern)

    - #### protected java.lang.String getDefaultExtension()

    - #### protected java.lang.String getDefaultGroup()

    - #### @groovy.transform.CompileStatic(TypeCheckingMode.SKIP) void invokeForString(java.lang.String scope, java.util.List<java.lang.Object> objects, groovy.lang.Closure configurer = null)

    - #### java.lang.Object methodMissing(java.lang.String name, java.lang.Object args)

    - #### void optional(java.lang.String pattern, @groovy.lang.DelegatesTo(DependencyConfiguration) groovy.lang.Closure customizer = null)

    - #### void optional(java.util.Map<java.lang.String, java.lang.String> properties, @groovy.lang.DelegatesTo(DependencyConfiguration) groovy.lang.Closure customizer = null)

    - #### void provided(java.lang.String pattern, @groovy.lang.DelegatesTo(DependencyConfiguration) groovy.lang.Closure customizer = null)

    - #### void provided(java.util.Map<java.lang.String, java.lang.String> properties, @groovy.lang.DelegatesTo(DependencyConfiguration) groovy.lang.Closure customizer = null)

    - #### void runtime(java.lang.String pattern, @groovy.lang.DelegatesTo(DependencyConfiguration) groovy.lang.Closure customizer = null)

    - #### void runtime(java.util.Map<java.lang.String, java.lang.String> properties, @groovy.lang.DelegatesTo(DependencyConfiguration) groovy.lang.Closure customizer = null)

    - #### void test(java.lang.String pattern, @groovy.lang.DelegatesTo(DependencyConfiguration) groovy.lang.Closure customizer = null)

    - #### void test(java.util.Map<java.lang.String, java.lang.String> properties, @groovy.lang.DelegatesTo(DependencyConfiguration) groovy.lang.Closure customizer = null)